#ifndef _USB_INIT__
#define _USB_INIT__
#include <iostream>
#include <string>
#include <algorithm>
#include <poll.h>
#include <cstdlib>
#include <signal.h>
#include <unistd.h>

int usb_out(std::string const& str);


namespace edn {
using std::cout;
using std::cerr;
using std::endl;
using std::ostream;
using std::string;


void delay(unsigned secs);
static void SetupHandler(int sig,void (*handler)(int));
void  Si_handler(int sig);
void  Sq_handler(int sig);
static int Nm = 0;

const std::string HexString = "01234567890:abcdefABCDEF";
inline std::ostream &stream0(std::ostream &stream){
	stream << "\e[s\e[60D\e[30;1m Ouch...! [" << Nm << "] \e[u\e[0m";
return stream;
}

inline std::ostream &stream1(std::ostream &stream){
	stream << "\e[s\e[60D\e[32;1m Ouch...! [" << Nm << "] \e[u\e[0m";
return stream;
}

void  Si_handler(int sig){
using namespace edn;
	signal(sig,SIG_IGN);
	Nm++;
	cerr << stream0;
signal(SIGINT,Si_handler);
}

void  Sq_handler(int sig){
using namespace edn;
	signal(sig,SIG_IGN);
	Nm++;
	cerr << stream1;
signal(SIGQUIT,Sq_handler);
}

static void SetupHandler(int sig,void (*handler)(int)){
	struct sigaction action;
	action.sa_handler = handler;
	sigemptyset(&(action.sa_mask));
	sigaddset(&(action.sa_mask),sig);
	action.sa_flags = 0;
	sigaction(sig,&action,0);
}

void delay(unsigned secs) {
	struct pollfd mypoll;
	unsigned int timeout;
	secs = secs * 1000000;
if ((timeout = secs / 1000) <= 0)
	timeout = 1;
	poll(&mypoll,0,timeout);
}


} //ns
#endif
